;*** Coordinate chart definition by Ralph Burkey ***
;*** Copyright 1994 Ralph Burkey ***
(Defun C:Cordchrt ()
   (setvar "CMDECHO" 0)
(defun dtr (a)
      (* pi (/ a 180.0))
)

(setq fname1 "CORTITLE.DWG")
(setq fname2 "CORENTRY.DWG")
(setq file1 (open fname1 "r"))
(setq file2 (open fname2 "r"))
(if (or (= file1 nil)
        (= file2 nil)
    )
  (progn
  (setq msg1 "\n Chart title block (CORTITLE.DWG) and entry block (CORENTRY.DWG) must be in AutoCAD search path. ")
  (setq msg2 "\n Check block locations and try again. ")
  (princ msg1)
  (princ msg2)
  );progn
  (progn
  (setq val 0)
  (setq chk (strcase (getstring "\nIs this a new chart or a continuation? (N or C) <N> ")))
  (while (= val 0)
    (if (= chk "N")
        (setq val 1)
        (if (= chk "C")
            (setq val 2)
            (if (= chk "")
                (setq val 1)
                (setq chk (getstring "\nN or C, please: "))
            );if
        );if
    );if
  );while
  (while (= val 1)
    (setq pt1 (getpoint "\nSet upper left corner of chart: "))
    (setq blpvar (getvar "BLIPMODE"))
    (setvar "BLIPMODE" 0)
    (setq scl (getvar "DIMSCALE"))
    (setq pt3 (polar pt1 (dtr 270) (* scl 0.50)))
    (command "INSERT" "CORTITLE" pt1 scl "" "")
    (setvar "BLIPMODE" blpvar)
    (setq XY (getpoint "\nChoose point for 0,0 datum: "))
    (setvar "BLIPMODE" 0)
    (setq dec (getint "\nHow many decimal places for coordinates on chart? "))
    (setq X (car XY))
    (setq XX (rtos X 2 dec))
    (setq Y (cadr XY))
    (setq YY (rtos Y 2 dec))
    (setq fr1 (strcase (getstring "\nEnter decimal places for diameter display or 0 for fractions: ")))
    (setq nme 1)
    (setq LL (list X Y))
    (setq MM (polar LL (dtr 270) (* scl 0.25)))
    (command "TEXT" "S" "STANDARD" "C" MM "" "" "(0,0)")
    (setq quest (strcat "Any " "comments? " " (N or Comment) <N> "))
    (setq query "N")
    (setq val 3)
  );while
  (while (= val 2)
    (setq blpvar (getvar "BLIPMODE"))
    (setq XY (getpoint "\nSelect existing 0,0 datum: "))
    (setq scl (getvar "DIMSCALE"))
    (setvar "BLIPMODE" 0)
    (setq dec (getint "\nHow many decimal places for coordinates on chart? "))
    (setq X (car XY))
    (setq XX (rtos X 2 dec))
    (setq Y (cadr XY))
    (setq YY (rtos Y 2 dec))
    (setq fr1 (strcase (getstring "\nEnter decimal places for diameter display or 0 for fractions: ")))
    (setq nme (getint "\nWhat number for the first hole? "))
    (setvar "CMDECHO" 0)
    (setq pt3 (getpoint "\nSelect lower left corner of existing chart: "))
    (setq LL (list X Y))
    (setq MM (polar LL (dtr 270) (* scl 0.25)))
    (setq quest (strcat "Any " "comments? " " (N or Comment) <N> "))
    (setq query "N") 
    (setq val 3)
  );while
  (while (= val 3)
    (setvar "CMDECHO" 0)
    (setvar "BLIPMODE" blpvar)
    (setq test 0)
    (setq z (entsel "\nChoose hole to list: "))
    (while (/= test 1)
      (while (= z nil) 
        (setq z (entsel "\nHole not found...try again: "))
      );while
      (setq P (entget (car z)))
      (setq zent (car z))
      (setq type (cdr (assoc 0 P)))
      (if (= type "CIRCLE")
          (progn
          (setq test 1)
          (redraw zent 3)
          );progn
          (if (/= type "ARC")
              (setq z (entsel "\nEntity selected is not a circle or an arc...try again: "))
              (progn
              (setq test 1)
              (redraw zent 3)
              );progn
          );if
      );if
    );while
    (setvar "BLIPMODE" 0)
    (setq Q (cadr (assoc 10 P)))       ; gets x of circle ;
    (setq Q1 (- Q X))                  ; gets x in relation to 0,0 ;
    (setq W (rtos Q1 2 dec))           ; sets decimal places for x ;
    (setq R (caddr (assoc 10 P)))      ; gets y of circle ;
    (setq R1 (- R Y))                  ; gets y in relation to 0,0 ;
    (setq U (rtos R1 2 dec))           ; sets decimal places for y ;
    (setq S (cdr (assoc 40 P)))        ; gets radius of circle ;
    (setq S2 (* S 2.0))                ; gets diameter of circle ;
    (if (= fr1 "0")
        (progn
        (setq v (rtos s2 5 6))
        (if (= (substr v 2 1) " ")
            (setq v (strcat (substr v 1 1) "-" (substr v 3 (strlen v))))
            (if (= (substr v 3 1) " ")
                (setq v (strcat (substr v 1 2) "-" (substr v 4 (strlen v))))
                (if (= (substr v 4 1) " ")
                    (setq v (strcat (substr v 1 3) "-" (substr 5 (strlen v))))
                );if
            );if
        );if
        );progn
        (progn
        (setq fr2 (atoi fr1)) 
        (setq V (rtos S2 2 fr2))
        );progn
    );if; sets decimal places for diameter ;
    (setq LL (list Q R))
    (setq MM (polar LL (dtr 270) (+ S (* scl 0.125))))
    (setq query1 query)
    (setq query (getstring T quest))
    (if (= query "")
        (setq query query1)
    );if
    (if (or (= query "N")
            (= query "n")
        );or
        (progn
        (setq LL (list Q R))
        (setq MM (polar LL (dtr 270) (+ S (* scl 0.125))))
        (setq query "")
        );progn
    );if
    (command "INSERT" "CORENTRY" pt3 scl "" "" nme W U V query)
    (command "TEXT" "S" "STANDARD" "M" MM "" "" nme)
    (setq nme (1+ nme))
    (setq pt3 (polar pt3 (dtr 270) (* scl 0.25)))
    (if (= query "")
        (setq query "N")
    );if
    (setq quest (strcat "Any comments? (N or Comment) <" query "> "))
    (setvar "BLIPMODE" blpvar)
    (setvar "CMDECHO" 1)
    (redraw zent 4)
    (setq val 4)
    (setq lim (strcase (getstring "\nDo you wish to continue? (Y or N) <Y> ")))
    (while (= val 4)
      (if (= lim "N")(setq val 5)
          (if (= lim "Y")(setq val 3)
              (if (= lim "")(setq val 3)
                  (setq lim (getstring "\nY or N, please: "))
              );if
          );if
      );if
    );while
  );while
  );progn
);if
(prin1)
)
